/*******************************************************
 *
 *  File: boot2nd.h
 *
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2001, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************/

#ifndef __BOOT2ND_H
#define __BOOT2ND_H


/* from entry.S */
void _restart_boot2nd(unsigned** memory_map, unsigned* aBootAdr);
void _boot_kernel(unsigned* aBootAdr, int arch_no);


unsigned** relocate_section(unsigned** src, unsigned** free_page, unsigned* dst, int blocks, int* relocated, int block_feedback);
void relocate_main(unsigned** memory_map, unsigned** section_start);
void copy_page(unsigned* dst, const unsigned* src);



#ifdef __CRC__

#define CRC_FIELD(page, where)	(((unsigned*) (page)) + 128 + (16 * (where)))
void crc_sections(unsigned** memory_map, int where);
void crc_calculate(unsigned** memory_map);
void crc_verify(unsigned** memory_map, int wait);
void crc_verify_primitive(unsigned** memory_map, int level);

#define CRC_CALCULATE(map) 					crc_calculate(map)
#define CRC_VERIFY(map, wait)				crc_verify(map, wait)
#define CRC_VERIFY_PRIMITIVE(map, level)	crc_verify_primitive(map, level)

#else

#define CRC_CALCULATE(map) 					/**/
#define CRC_VERIFY(map, wait)				/**/
#define CRC_VERIFY_PRIMITIVE(map, level)	/**/

#endif


#endif			/* __BOOT2ND_H */

