#define __ASM_ONLY__
#include "boot2nd_if.h"	
	
/*
 * _start
 *
 * Parameters:
 *   r0: memory map passed in by boot1st (Arlo)
 *
 */	
	.align
	.text
	.global _start
_start:
		/*
		 * setup and clear stack PAGE
		 */
	add  r1, r0, #(PAGE_NO_STACK << 2)
	ldr  r2, [r1]
	add  r2, r2, #4096
#if 0
	mov  r4, #0
	mov  r3, #(PAGE_SIZE >> 2)
1:	str  r4, [r2]
	add  r2, r2, #4
	subs r3, r3, #1
	bne  1b
#endif

	subs r2, r2, #16
	mov  sp, r2

	b    boot2nd_main


/*
 * _restart_boot2nd
 *
 * Parameters:
 *   r0: memory map passed in by Arlo
 *   r1: our boot address
 *
 */	
	.global _restart_boot2nd
_restart_boot2nd:
	mov pc, r1

	
	
/*
 * _boot_kernel
 *
 * Parameters:
 *   r0: kernel boot address
 *   r1: architecture number
 *
 */	
	.global _boot_kernel
_boot_kernel:
	mov r6, r0
	mov r0, #0
	mov pc, r6
