/*******************************************************
 *
 *  File: lib.c
 *
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2001, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************/

#include "lib.h"

/*******************************************
 *
 * Interface functions
 *
 *******************************************/

int strlen(const char* str)
{
	int	len = 0;
	while(*str++)
		len++;
	return len;
}

char* strcpy(char* dst, const char* src)
{
	char*	tmp = dst;
	while(*src)
		*dst++ = *src++;
	return tmp;
}

char* itoa_hex(unsigned num, char* str)
{
	int		i, count;
	int		digit;
	char*	s = str;
	
	*str++ = '0';
	*str++ = 'x';
	count = 0;
	for(i=0 ; i<8 ; i++)
	{
		digit = num >> 28;
		if (digit)
		{
			*str++ = (digit < 10) ? digit + '0' : (digit - 10) + 'A';
			count++;
		}
		num <<= 4;
	}
	if (!count)
		*str++ = '0';
	*str = 0;
	return s;
}







